package com.application.GUI.Panes;

import com.application.DB.Constants;
import com.application.GUI.LineChartFunctionality;
import com.application.Main;
import javafx.geometry.Pos;
import javafx.scene.control.CheckBox;
import javafx.scene.control.Label;
import javafx.scene.layout.HBox;

/**
 * This class creates the bottombar
 *
 * @author Eilert Tunheim, Karin Pettersen, Mads Arnesen
 * @version 1.0.0
 */
public class CreateBottomBar {
    private final Main main;

    public CreateBottomBar(Main main) {
        this.main = main;
    }

    /**
     * This function create the bottombar
     *
     * @return the finished bottombar
     */
    public HBox createBottomBar() {
        HBox hBox = new HBox();

        Label liveDataText = new Label("View Live Data");
        main.setLiveDataBox(new CheckBox());
        Main.getLiveDataBox().setSelected(Constants.DEFAULT_IS_SELECTED_LIVE_DATA);
        Main.getLiveDataBox().setOnAction(event -> {
            if (Main.getLiveDataBox().isSelected()) {
                LineChartFunctionality.setPrintLiveData(true);
                LineChartFunctionality.printGraphs();

            } else {
                LineChartFunctionality.setPrintLiveData(false);
                LineChartFunctionality.printGraphs();
            }
        });

        Label regressionText = new Label("View Regression");
        main.setRegressionBox(new CheckBox());
        Main.getRegressionBox().setSelected(Constants.DEFAULT_IS_SELECTED_REGRESSION);
        Main.getRegressionBox().setOnAction(event -> {
            if (Main.getRegressionBox().isSelected()) {
                LineChartFunctionality.setPrintRegression(true);
                LineChartFunctionality.printGraphs();

            } else {
                LineChartFunctionality.setPrintRegression(false);
                LineChartFunctionality.printGraphs();
            }
        });

        Label regressionConfidenceIntervalText = new Label("View Regression Shadow");
        main.setRegressionConfidenceIntervalBox(new CheckBox());
        Main.getRegressionConfidenceIntervalBox().setSelected(Constants.DEFAULT_IS_SELECTED_REGRESSION_SHADOW);
        Main.getRegressionConfidenceIntervalBox().setOnAction(event -> {
            if (Main.getRegressionConfidenceIntervalBox().isSelected()) {
                LineChartFunctionality.setPrintRegressionConfidenceInterval(true);
                LineChartFunctionality.printGraphs();
            } else {
                LineChartFunctionality.setPrintRegressionConfidenceInterval(false);
                LineChartFunctionality.printGraphs();
            }
        });

        Label previousText = new Label("View Previous Data");
        main.setPreviousBox(new CheckBox());
        Main.getPreviousBox().setSelected(Constants.DEFAULT_IS_SELECTED_PREVIOUS_DATA);
        Main.getPreviousBox().setOnAction(event -> {
            if (Main.getPreviousBox().isSelected()) {
                LineChartFunctionality.setPrintPreviousData(true);
                LineChartFunctionality.printGraphs();
            } else {
                LineChartFunctionality.setPrintPreviousData(false);
                LineChartFunctionality.printGraphs();
            }
        });

        // Adds all the components to the HBox
        hBox.getChildren().addAll(liveDataText, Main.getLiveDataBox(), regressionText, Main.getRegressionBox(), regressionConfidenceIntervalText, Main.getRegressionConfidenceIntervalBox(), previousText, Main.getPreviousBox());
        hBox.setAlignment(Pos.CENTER_RIGHT);
        hBox.setSpacing(5);

        return hBox;
    }
}